Bug 1733707 - Review Request: multi-git-status - Show uncommitted, untracked and unpushed changes for multiple Git repos
Summary: Review Request: multi-git-status - Show uncommitted, untracked and unpushed c...
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Björn 'besser82' Esser
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2019-07-27 18:54 UTC by Brian (bex) Exelbierd
Modified: 2019-08-01 22:25 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-08-01 22:25:07 UTC
besser82: fedora-review+


Attachments (Terms of Use)

Description Brian (bex) Exelbierd 2019-07-27 18:54:54 UTC
Spec URL: https://bex.fedorapeople.org/multi-git-status/multi-git-status.spec
SRPM URL: https://bex.fedorapeople.org/multi-git-status/multi-git-status-0-1.20190727gitb203cca.fc30.src.rpm
Description: Show uncommitted, untracked and unpushed changes for multiple Git repos.

multi-git-status shows:
* Uncommitted changes if there are unstaged or uncommitted changes on the
  checked out branch.
* Untracked files if there are untracked files which are not ignored.
* Needs push (BRANCH) if the branch is tracking a (remote) branch which is
  behind.
* Needs upstream (BRANCH) if a branch does not have a local or remote
  upstream branch configured. Changes in the branch may otherwise
  never be pushed or merged.
* Needs pull (BRANCH) if the branch is tracking a (remote) branch which is
  ahead. This requires that the local git repo already knows about the remote
  changes (i.e. you've done a fetch), or that you specify the -f option.
  Multi-git-status does NOT contact the remote by default.
* X stashes if there are stashes.

Fedora Account System Username: bex

Comment 1 Björn 'besser82' Esser 2019-07-27 21:09:08 UTC
Thre package builds fine on Koji:

  https://koji.fedoraproject.org/koji/taskinfo?taskID=36620481


The package lacks the following runtime requirements to function properly:

Requires:        coreutils
Requires:        findutils
Requires:        gawk
Requires:        git
Requires:        sed


Otherwise the package seems fine, but I'll do a full review after the requirements have been fixed.

Comment 2 Brian (bex) Exelbierd 2019-07-27 21:34:22 UTC
Thank you, Björn, for catching those Requires.  I had on my list to test this in a clean VM and then got distracted by something locally.

The files are updated at the same urls.

I noticed that your suggestions includes a few things like sed that seem to be default installed in Fedora.  Is there a good way to catch those, other than looking for them (and focusing on them) in a read of the script?

Comment 3 Benjamin Kircher 2019-07-28 06:59:02 UTC
Installed and played around. Looks good to me.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Expat License", "Unknown or generated". 4 files have unknown
     license. Detailed output of licensecheck in /home/bkircher/pkgs/multi-
     git-status/multi-git-status/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[ ]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[ ]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 71680 bytes in 2 files.
[ ]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[!]: Latest version is packaged.
[-]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[ ]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Checking: multi-git-status-0-1.20190727gitb203cca.fc31.noarch.rpm
          multi-git-status-0-1.20190727gitb203cca.fc31.src.rpm
multi-git-status.noarch: W: spelling-error Summary(en_US) untracked -> backtracked, tracked
multi-git-status.noarch: W: spelling-error Summary(en_US) unpushed -> unpunished, punished, pushed
multi-git-status.noarch: W: spelling-error Summary(en_US) repos -> ropes, reps, repose
multi-git-status.noarch: W: spelling-error %description -l en_US untracked -> backtracked, tracked
multi-git-status.noarch: W: spelling-error %description -l en_US unpushed -> unpunished, punished, pushed
multi-git-status.noarch: W: spelling-error %description -l en_US repos -> ropes, reps, repose
multi-git-status.noarch: W: spelling-error %description -l en_US unstaged -> unstated, upstaged, unstained
multi-git-status.noarch: W: spelling-error %description -l en_US repo -> rope, rep, reps
multi-git-status.noarch: W: no-manual-page-for-binary mgitstatus
multi-git-status.src: W: spelling-error Summary(en_US) untracked -> backtracked, tracked
multi-git-status.src: W: spelling-error Summary(en_US) unpushed -> unpunished, punished, pushed
multi-git-status.src: W: spelling-error Summary(en_US) repos -> ropes, reps, repose
multi-git-status.src: W: spelling-error %description -l en_US untracked -> backtracked, tracked
multi-git-status.src: W: spelling-error %description -l en_US unpushed -> unpunished, punished, pushed
multi-git-status.src: W: spelling-error %description -l en_US repos -> ropes, reps, repose
multi-git-status.src: W: spelling-error %description -l en_US unstaged -> unstated, upstaged, unstained
multi-git-status.src: W: spelling-error %description -l en_US repo -> rope, rep, reps
2 packages and 0 specfiles checked; 0 errors, 17 warnings.




Rpmlint (installed packages)
----------------------------
perl: warning: Setting locale failed.
perl: warning: Please check that your locale settings:
	LANGUAGE = (unset),
	LC_ALL = (unset),
	LC_CTYPE = "C.UTF-8",
	LANG = "en_US.UTF-8"
    are supported and installed on your system.
perl: warning: Falling back to the standard locale ("C").
perl: warning: Setting locale failed.
perl: warning: Please check that your locale settings:
	LANGUAGE = (unset),
	LC_ALL = (unset),
	LC_CTYPE = "C.UTF-8",
	LANG = "en_US.UTF-8"
    are supported and installed on your system.
perl: warning: Falling back to the standard locale ("C").
multi-git-status.noarch: W: spelling-error Summary(en_US) untracked -> backtracked, tracked
multi-git-status.noarch: W: spelling-error Summary(en_US) unpushed -> unpunished, punished, pushed
multi-git-status.noarch: W: spelling-error Summary(en_US) repos -> ropes, reps, repose
multi-git-status.noarch: W: spelling-error %description -l en_US untracked -> backtracked, tracked
multi-git-status.noarch: W: spelling-error %description -l en_US unpushed -> unpunished, punished, pushed
multi-git-status.noarch: W: spelling-error %description -l en_US repos -> ropes, reps, repose
multi-git-status.noarch: W: spelling-error %description -l en_US unstaged -> unstated, upstaged, unstained
multi-git-status.noarch: W: spelling-error %description -l en_US repo -> rope, rep, reps
multi-git-status.noarch: W: invalid-url URL: https://github.com/fboender/multi-git-status <urlopen error [Errno -2] Name or service not known>
multi-git-status.noarch: W: no-manual-page-for-binary mgitstatus
1 packages and 0 specfiles checked; 0 errors, 10 warnings.



Source checksums
----------------
https://github.com/fboender/multi-git-status/archive/b203cca071641928e2be611de1f03c58f849cb92/multi-git-status-b203cca071641928e2be611de1f03c58f849cb92.tar.gz :
  CHECKSUM(SHA256) this package     : 2e94ceedcd3db10b283381dc4374e63ef2c646cdbe0b353ab02bc018376df6ce
  CHECKSUM(SHA256) upstream package : 2e94ceedcd3db10b283381dc4374e63ef2c646cdbe0b353ab02bc018376df6ce


Requires
--------
multi-git-status (rpmlib, GLIBC filtered):
    /usr/bin/sh
    coreutils
    findutils
    gawk
    git
    sed



Provides
--------
multi-git-status:
    multi-git-status



Generated by fedora-review 0.7.2 (65d36bb) last change: 2019-04-09
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 --rpm-spec -n multi-git-status-0-1.20190727gitb203cca.fc30.src.rpm
Buildroot used: fedora-rawhide-x86_64
Active plugins: Shell-api, Generic
Disabled plugins: C/C++, Python, Perl, Java, PHP, R, SugarActivity, Haskell, Ocaml, fonts
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 4 Brian (bex) Exelbierd 2019-07-28 09:07:28 UTC
Updated spec and srpm to reflect a partial move to versioning by the upstream (at my request).  With the next release they will use forge releases.

Spec URL: https://bex.fedorapeople.org/multi-git-status/multi-git-status.spec
SRPM URL: https://bex.fedorapeople.org/multi-git-status/multi-git-status-1.0-1.20190728git2e6049d.fc30.src.rpm
Description: Show uncommitted, untracked and unpushed changes for multiple Git repos.

multi-git-status shows:
* Uncommitted changes if there are unstaged or uncommitted changes on the
  checked out branch.
* Untracked files if there are untracked files which are not ignored.
* Needs push (BRANCH) if the branch is tracking a (remote) branch which is
  behind.
* Needs upstream (BRANCH) if a branch does not have a local or remote
  upstream branch configured. Changes in the branch may otherwise
  never be pushed or merged.
* Needs pull (BRANCH) if the branch is tracking a (remote) branch which is
  ahead. This requires that the local git repo already knows about the remote
  changes (i.e. you've done a fetch), or that you specify the -f option.
  Multi-git-status does NOT contact the remote by default.
* X stashes if there are stashes.

Fedora Account System Username: bex

Comment 5 Björn 'besser82' Esser 2019-07-30 12:19:36 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Expat License", "Unknown or generated". 4 files have unknown
     license. Detailed output of licensecheck in
     /home/besser82/fedora/review/1733707-multi-git-status/licensecheck.txt
     
     ---> License is fine.  Expat and MIT are identical licenses.
     
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 71680 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: multi-git-status-1.0-1.20190728git2e6049d.fc31.noarch.rpm
          multi-git-status-1.0-1.20190728git2e6049d.fc31.src.rpm
multi-git-status.noarch: W: spelling-error Summary(en_US) untracked -> backtracked, tracked
multi-git-status.noarch: W: spelling-error Summary(en_US) unpushed -> unpunished, punished, pushed
multi-git-status.noarch: W: spelling-error Summary(en_US) repos -> ropes, reps, repose
multi-git-status.noarch: W: spelling-error %description -l en_US untracked -> backtracked, tracked
multi-git-status.noarch: W: spelling-error %description -l en_US unpushed -> unpunished, punished, pushed
multi-git-status.noarch: W: spelling-error %description -l en_US repos -> ropes, reps, repose
multi-git-status.noarch: W: spelling-error %description -l en_US unstaged -> unstated, upstaged, unstained
multi-git-status.noarch: W: spelling-error %description -l en_US repo -> rope, rep, reps
multi-git-status.noarch: W: no-manual-page-for-binary mgitstatus
multi-git-status.src: W: spelling-error Summary(en_US) untracked -> backtracked, tracked
multi-git-status.src: W: spelling-error Summary(en_US) unpushed -> unpunished, punished, pushed
multi-git-status.src: W: spelling-error Summary(en_US) repos -> ropes, reps, repose
multi-git-status.src: W: spelling-error %description -l en_US untracked -> backtracked, tracked
multi-git-status.src: W: spelling-error %description -l en_US unpushed -> unpunished, punished, pushed
multi-git-status.src: W: spelling-error %description -l en_US repos -> ropes, reps, repose
multi-git-status.src: W: spelling-error %description -l en_US unstaged -> unstated, upstaged, unstained
multi-git-status.src: W: spelling-error %description -l en_US repo -> rope, rep, reps
2 packages and 0 specfiles checked; 0 errors, 17 warnings.




Rpmlint (installed packages)
----------------------------
perl: warning: Setting locale failed.
perl: warning: Please check that your locale settings:
	LANGUAGE = (unset),
	LC_ALL = (unset),
	LC_CTYPE = "C.UTF-8",
	LANG = "de_DE.UTF-8"
    are supported and installed on your system.
perl: warning: Falling back to the standard locale ("C").
perl: warning: Setting locale failed.
perl: warning: Please check that your locale settings:
	LANGUAGE = (unset),
	LC_ALL = (unset),
	LC_CTYPE = "C.UTF-8",
	LANG = "de_DE.UTF-8"
    are supported and installed on your system.
perl: warning: Falling back to the standard locale ("C").
multi-git-status.noarch: W: spelling-error Summary(en_US) untracked -> backtracked, tracked
multi-git-status.noarch: W: spelling-error Summary(en_US) unpushed -> unpunished, punished, pushed
multi-git-status.noarch: W: spelling-error Summary(en_US) repos -> ropes, reps, repose
multi-git-status.noarch: W: spelling-error %description -l en_US untracked -> backtracked, tracked
multi-git-status.noarch: W: spelling-error %description -l en_US unpushed -> unpunished, punished, pushed
multi-git-status.noarch: W: spelling-error %description -l en_US repos -> ropes, reps, repose
multi-git-status.noarch: W: spelling-error %description -l en_US unstaged -> unstated, upstaged, unstained
multi-git-status.noarch: W: spelling-error %description -l en_US repo -> rope, rep, reps
multi-git-status.noarch: W: invalid-url URL: https://github.com/fboender/multi-git-status <urlopen error [Errno -2] Name or service not known>
multi-git-status.noarch: W: no-manual-page-for-binary mgitstatus
1 packages and 0 specfiles checked; 0 errors, 10 warnings.



Source checksums
----------------
https://github.com/fboender/multi-git-status/archive/2e6049d4286bf26ceabf5c6ec174bd6f5fc84b32/multi-git-status-2e6049d4286bf26ceabf5c6ec174bd6f5fc84b32.tar.gz :
  CHECKSUM(SHA512) this package     : f441a7288647be6dffb1fc284efecc3579bd3547af80de32caf6264e3f6b22d22f55fad31fa970381208adea80889cd5b0bfab9e94f0fe0026f84f1783837649
  CHECKSUM(SHA512) upstream package : f441a7288647be6dffb1fc284efecc3579bd3547af80de32caf6264e3f6b22d22f55fad31fa970381208adea80889cd5b0bfab9e94f0fe0026f84f1783837649


Requires
--------
multi-git-status (rpmlib, GLIBC filtered):
    /usr/bin/sh
    coreutils
    findutils
    gawk
    git
    sed



Provides
--------
multi-git-status:
    multi-git-status



Generated by fedora-review 0.7.2 (65d36bb) last change: 2019-04-09
Command line :/usr/bin/fedora-review -k sha512 -m fedora-rawhide-x86_64 -b 1733707
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api
Disabled plugins: Java, Ocaml, C/C++, Perl, Ruby, fonts, R, PHP, Python, SugarActivity, Haskell
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH


===== Solution =====

Package APPROVED!


***


(In reply to Brian (bex) Exelbierd from comment #2)
> Thank you, Björn, for catching those Requires.  I had on my list to test
> this in a clean VM and then got distracted by something locally.
> 
> The files are updated at the same urls.
> 
> I noticed that your suggestions includes a few things like sed that seem to
> be default installed in Fedora.  Is there a good way to catch those, other
> than looking for them (and focusing on them) in a read of the script?

You're welcome!

Besides checking the script closely for the used commands, one can run the script using `bash -x $script` which will result in verbose console output, listing all commands executed by the script.

Comment 6 Gwyn Ciesla 2019-07-30 19:23:53 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/multi-git-status


Note You need to log in before you can comment on or make changes to this bug.